#include <stdio.h>
typedef void (*VFUNCP)();

#include <sys/lwp.h>
#define STKSIZE 0x20000


static thread1(av)
	char *av[];
{	VFUNCP func;

	func = (VFUNCP)av[0];
	(*func)(av[1],av[2],av[3],av[4],av[5],av[6],av[7]);
	/*porting_dbg("thread_exit()");*/
	free(av);
	_lwp_exit();
	/*porting_dbg("thread_exit() failed.");*/
	exit(-1);
}

static thread_fork(ssize,func,a1,a2,a3,a4,a5,a6,a7,a8)
	VFUNCP func;
	char *a1,*a2,*a3,*a4,*a5,*a6,*a7,*a8;
{	ucontext_t *ctx;
	caddr_t stk;
        lwpid_t lwp;
        int err;
	char **av;

	av = (char **)malloc(sizeof(void*)*8);
	av[0] = (char*)func;
	av[1] = a1; av[2] = a2; av[3] = a3;
	av[4] = a4; av[5] = a5; av[6] = a6; av[7] = a7;

	if( ssize == 0 )
		ssize = STKSIZE;

	ctx = (ucontext_t*)malloc(sizeof(ucontext_t));
	/*
	stk = (caddr_t)malloc(STKSIZE);
	*/
	stk = (caddr_t)malloc(ssize);
	_lwp_makecontext(ctx,(VFUNCP)thread1,(void*)av,(void*)NULL,stk,ssize);
	err = _lwp_create(ctx,NULL,&lwp);
	/*porting_dbg("thread_fork() = %d",lwp);*/
	return lwp;
}

char *WithThread = "_lwp_create";
int (*ThreadFork)() = thread_fork;
int (*ThreadYield)() = 0;
